/*
 * =============================================================================
 *
 *       Filename:  barOverlay.js
 *
 *    Description: jscript code attached to the main extension overlay, code for
 *		   scanning 1/2 file + options window
 *
 *        Version:  1.0
 *        Created:  ?
 *       Revision:  none
 *       Compiler:  mozilla - firefox
 *
 *         Author:  Andrei Hanganu (), ahanganu@bitdefender.com
 *        Company:  BitDefender SRL
 *    Modified by:  Dumitru Codreanu, dcodreanu@bitdefender.com
 * =============================================================================
 */

var stringService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
var strings = stringService.createBundle("chrome://bdqscan/locale/global.properties");
var initialized = 0;
 
function strFromName(name){
	/* return a string from the string bundle */
	return strings.GetStringFromName(name);
}

function dbg_log(str){
/* debugging function - output both in jscript console and in the component's debug file */
//var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
//                                 .getService(Components.interfaces.nsIConsoleService);
//  consoleService.logStringMessage("BDQuickScan: "+str);
}

var bdqscan_comp=0;



function on_load(){
dbg_log("OnLoad called");

var obj = document.getElementById("bdqscan-toolbarbutton");
if(obj)
obj.setAttribute('class',"toolbarbuttonloading");

obj = document.getElementById("bdStatusIcon");
obj.addEventListener("click",qscan,false);

dbg_log("trying to initialize");
				 
	try {
		if(bdqscan_comp==0){
			dbg_log("bdqscan_comp==0");
			bdqscan_comp = Components.classes["@bitdefender.com/QScan/QScan;1"].getService(Components.interfaces.IBDQScan);
			if(!bdqscan_comp){
				dbg_log("BitDefender QuickScan is damaged, please reinstall extension.");
			 	obj.setAttribute('tooltiptext',strFromName("tip_off"));
				obj.setAttribute('src',"chrome://bdqscan/skin/images/bitdef-off.png"); 
				obj = document.getElementById("bdqscan-toolbarbutton");
				if(obj)
					obj.setAttribute('class',"toolbarbuttonoff");
				initialized = -1;
				return;
			}
		}
		
		 var obj = document.getElementById("bdStatusIcon");
		 obj.setAttribute('tooltiptext',strFromName("tip"));
		 obj.setAttribute('src',"chrome://bdqscan/skin/images/bitdef.png");
		obj = document.getElementById("bdqscan-toolbarbutton");
		if(obj)
			obj.setAttribute('class',"toolbarbuttonon");

		dbg_log("initialized succesfully");
		
		initialized = 1;
		
	} catch (e){
		alert("Instantiation of BitDefender Quick Scan failed, please reinstall extension.");
		obj.setAttribute('tooltiptext',strFromName("tip_off"));
		obj.setAttribute('src',"chrome://bdqscan/skin/images/bitdef-off.png"); 
		obj = document.getElementById("bdqscan-toolbarbutton");
		if(obj)
			obj.setAttribute('class',"toolbarbuttonoff");
		initialized = -1;
		
		return;
	}
}

function qscan(){
	
	if(initialized==-1)
	{
		alert("The BitDefender Quick Scan is missing components, please reinstall.");
		return;
	}
	
	if(bdqscan_comp && initialized==1){
	dbg_log("lunching");
	bdqscan_comp.RunQScan();
	dbg_log("end");
	return;
	}
}

window.addEventListener("load", on_load, false);

